> For the complete documentation index, see [llms.txt](https://docs.rasgoml.com/rasgo-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rasgoml.com/rasgo-docs/rasgo-0.1/all-transforms/cumulative_agg.md).

# Cumulative Agg

Row-based; Calculates a cumulative aggregate based on a relative row window.

Pass in order\_by columns to create a row-based look-back or look-forward window.

Example use case: Aggregate all sales for a customer from the beginning of time until this row.

## Parameters

| Name         | Type         | Description                                                                                                                                                                                                              | Is Optional |
| ------------ | ------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ----------- |
| aggregations | agg\_dict    | Dictionary of columns and aggregate functions to apply. A column can have a list of multiple aggregates applied. One column will be created for each column:aggregate pair.                                              |             |
| order\_by    | column\_list | Column(s) to order rows by when calculating the agg window                                                                                                                                                               |             |
| direction    | value        | By default, the cumulative agg will calculate by looking 'backward' across all rows, according to the order\_by. To override this behavior, use 'forward', and the cumulative will look at each row and all future rows. | True        |
| group\_by    | column\_list | Column(s) to group by when calculating the agg window                                                                                                                                                                    | True        |

## Example

```python
internet_sales = rasgo.get.dataset(74)

ds = internet_sales.cumulative_agg(
        aggregations={
          "SALESAMOUNT": ['SUM', 'MIN', 'MAX']
        },
        group_by=['PRODUCTKEY'],
        order_by=['ORDERDATE'],
        direction='forward'
       )

```

## Source Code

{% embed url="<https://github.com/rasgointelligence/RasgoTransforms/blob/main/rasgotransforms/rasgotransforms/transforms/cumulative_agg/cumulative_agg.sql>" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rasgoml.com/rasgo-docs/rasgo-0.1/all-transforms/cumulative_agg.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
